// RAINBOND, Application Management Platform
// Copyright (C) 2014-2020 Goodrain Co., Ltd.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version. For any non-GPL usage of Rainbond,
// one or multiple Commercial Licenses authorized by Goodrain Co., Ltd.
// must be obtained first.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/goodrain/rainbond-operator/pkg/apis/rainbond/v1alpha1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// RainbondPackageLister helps list RainbondPackages.
type RainbondPackageLister interface {
	// List lists all RainbondPackages in the indexer.
	List(selector labels.Selector) (ret []*v1alpha1.RainbondPackage, err error)
	// RainbondPackages returns an object that can list and get RainbondPackages.
	RainbondPackages(namespace string) RainbondPackageNamespaceLister
	RainbondPackageListerExpansion
}

// rainbondPackageLister implements the RainbondPackageLister interface.
type rainbondPackageLister struct {
	indexer cache.Indexer
}

// NewRainbondPackageLister returns a new RainbondPackageLister.
func NewRainbondPackageLister(indexer cache.Indexer) RainbondPackageLister {
	return &rainbondPackageLister{indexer: indexer}
}

// List lists all RainbondPackages in the indexer.
func (s *rainbondPackageLister) List(selector labels.Selector) (ret []*v1alpha1.RainbondPackage, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.RainbondPackage))
	})
	return ret, err
}

// RainbondPackages returns an object that can list and get RainbondPackages.
func (s *rainbondPackageLister) RainbondPackages(namespace string) RainbondPackageNamespaceLister {
	return rainbondPackageNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// RainbondPackageNamespaceLister helps list and get RainbondPackages.
type RainbondPackageNamespaceLister interface {
	// List lists all RainbondPackages in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1alpha1.RainbondPackage, err error)
	// Get retrieves the RainbondPackage from the indexer for a given namespace and name.
	Get(name string) (*v1alpha1.RainbondPackage, error)
	RainbondPackageNamespaceListerExpansion
}

// rainbondPackageNamespaceLister implements the RainbondPackageNamespaceLister
// interface.
type rainbondPackageNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all RainbondPackages in the indexer for a given namespace.
func (s rainbondPackageNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.RainbondPackage, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.RainbondPackage))
	})
	return ret, err
}

// Get retrieves the RainbondPackage from the indexer for a given namespace and name.
func (s rainbondPackageNamespaceLister) Get(name string) (*v1alpha1.RainbondPackage, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("rainbondpackage"), name)
	}
	return obj.(*v1alpha1.RainbondPackage), nil
}
